﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Web;

namespace ValutaserviceWebApp
{

    // Da flere tråde på web
    // Der er ikke i denne trådsikret - det skal ske på alle metoder (også get) der ændre variable og tilgår nogle der kan blive ændret

    [DataContract]
    public class Valuta : IValuta
    {
        private string _iso;
        [DataMember]
        public string ISO
        {
            get { return _iso; }
            set { throw new NotSupportedException(); }  // af hensyn til brug som DTO på WCF
        }

        private string _land;
        [DataMember]
        public string Land
        {
            get { return _land; }
            set { throw new NotSupportedException(); }  // af hensyn til brug som DTO på WCF
        }
        private double _kurs;
        [DataMember]
        public double Kurs
        {
            get { return _kurs; }
            set { throw new NotSupportedException(); }  // af hensyn til brug som DTO på WCF
        }

        private int _version;
        [DataMember]
        public int Version
        {
            get { return _version; }
            set { throw new NotSupportedException(); }  // af hensyn til brug som DTO på WCF
        }

        public Valuta(string iso, string land, double kurs)
        {
            _iso = iso;
            _land = land;
            _kurs = kurs;
            _version = 1;
        }


        public void RetData(string land, double kurs, int version)
        {
            if (_version == version)
            {
                _land = land;
                _kurs = kurs;
            }
            else
                throw new InvalidOperationException("Version ikke korrekt");
        }
    }
}